#!/bin/sh
# RULE #1: exec long running commands in the background, let the handler finish

#EVENT=$2
ACTIONS=/etc/acpi/actions-my/

. ${ACTIONS}support/xaction
action() {
	. ${ACTIONS}$1
}

if [ "$1" = "ibm/hotkey" ]; then
	EVENT=$4;
else
	EVENT=$1
fi

case "$EVENT" in
# fnf1: tpfand
	'00001001'|'button/fnf1')
	action fan-toggle
	;;

# fnf2: xbindkeys: vlock -a -n
#	'button/screenlock')
#	;;

# fnf3: battery charging thresholds
	'00001003'|'button/battery')
	xaction battery
	;;

# fnf4: suspend
	'button/sleep'|'00001004')
	/usr/sbin/pm-suspend
	#dbus-send --system --print-reply --dest="org.freedesktop.Hal" /org/freedesktop/Hal/devices/computer org.freedesktop.Hal.Device.SystemPowerManagement.Suspend int32:0
	;;

# fnf5: all radio killswitch (thinkpad-acpi)
#	'button/wlan') ;;

# fnf6: scan wifi networks (wlan0)
	'00001006'|'button/fnf6')
	DEVICE=wlan0
	xaction wifi-scan
	;;

# fnf7: xrandr (triggered by monitor connection and disconnection IIRC)
#	'button/switchmode') ;;

# fnf8: xbindkeys script (toggle touchpad action):
#	'button/fnf8')
#	if synclient -l | grep TouchpadOff | grep -q 0; then
#	    synclient TouchpadOff=1;
#	else 
#	    synclient TouchpadOff=0;
#	fi

# fnf9: eject
#	'button/f24') ;;

# fnf10: no event

# fnf11: s2disk+s2ram
	'0000100b'|'button/fnf11')
	# needs swap: swapon -a?
	/usr/sbin/pm-suspend-hybrid
	;;

# fnf12: hibernate
	'button/suspend'|'0000100c')
	# needs swap: swapon -a?
	/usr/sbin/pm-hibernate
	;;

# fn-pgup: thinklight
#	'button/kbdillumtoggle') ;;

# fn-home, fn-end: brightness OSD (custom daemon)
#	'video/brightnessup'|'video/brightnessdown')
#	action brightness
#	;;

# volume: OSD updates handled by halevt
#	'button/volumeup'|'button/volumedown')
#	action volume
#	;;

# fn-space: zoom
	'00001014'|'button/zoom')
	xaction xrandr
	;;

# thinkvantage:
	'00001018'|'button/prog1'|'button/vendor')
	xaction thinkvantage
	;;

# AC adapter
	'ac_adapter')
	if [ $4 -gt 0 ]; then
		# or pm-powersave false
		for f in /etc/pm/power.d/*; do $f false || true; done
	else
		# or pm-powersave true
		for f in /etc/pm/power.d/*; do $f true || true; done

		# notification
		for x in /tmp/.X11-unix/*; do
			displaynum=`echo $x | sed s#/tmp/.X11-unix/X##`
			getXuser;
			if [ x"$XAUTHORITY" != x"" ]; then
				export DISPLAY=":$displaynum"
				sudo -u $user notify-send -u normal -t 3000 -i gtk-dialog-warning "Battery Discharging" "The AC power has been unplugged. The system is now using battery power."
			fi
		done
	fi
	;;
esac

#echo $1
